//+------------------------------------------------------------------+
//|                  MACD2 Crossover Arrows & Alert                  |
//|             Copyright  2006 Written by PussyGalore              |
//|          Modified Alert / NRP and Text Alert added by WR1        |
//+------------------------------------------------------------------+


#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 DodgerBlue
#property indicator_width1 1
#property indicator_color2 Crimson
#property indicator_width2 1

extern string note = "UP ARROW";
extern int  UP_MACD_Fast = 12;
extern int  UP_MACD_Slow = 29;
extern int  UP_MACD_Slowing = 9; 

extern string note_ = "DOWN ARROW";
extern int  DN_MACD_Fast = 12;
extern int  DN_MACD_Slow = 26;
extern int  DN_MACD_Slowing = 9; 

//extern int MA_Method=0; // SMA 0, EMA 1, SMMA 2, LWMA 3
extern int PriceField=0; // Low/High 0, Close/Close 1

extern bool ShowText = true;
extern bool AlertON  =true;
extern bool EmailON  =false;

extern int    TextPositionX    = 620;
extern int    TextPositionY    = 0;
extern color  UPTextcolor      = Blue;
extern color  DNTextcolor      = Red;

extern int    Fontsize            = 9;
extern double UParrowDisplacement = 2.5;
extern double DNarrowDisplacement = 2.5;


double CrossUp[];
double CrossDown[];
int flagval1=0;
int flagval2=0;
string TextDir = "M2 Text NRP";


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
  {
//---- indicators
   
   
   IndicatorBuffers(3);   
   SetIndexStyle(0, DRAW_ARROW, EMPTY);
   SetIndexArrow(0, 233);
   SetIndexBuffer(0, CrossUp);
   SetIndexStyle(1, DRAW_ARROW, EMPTY);
   SetIndexArrow(1, 234);
   SetIndexBuffer(1, CrossDown);
  
   

//----
     return(0);
  }

int deinit() 
{ 
   ObjectDelete(TextDir);return(0); 
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

   int start() {
   int limit, i, counter;
   double tmp=0;
   double UP_macdnow, UP_macd_signow, UP_macdprevious, UP_macd_sigprevious, UP_macdafter, UP_macd_sigafter;
   double  DN_macdnow,  DN_macd_signow,  DN_macdprevious,  DN_macd_sigprevious,  DN_macdafter,  DN_macd_sigafter;
   double Range, AvgRange;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   for(i=1; i<=limit; i++) 
     {
   counter=i;
   Range=0;
   AvgRange=0;
   for(counter=i ;counter<=i+9;counter++)
        {

         AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
      
      Range=AvgRange/10;
      UP_macdnow = iMACD(Symbol(), Period(), UP_MACD_Fast, UP_MACD_Slow, UP_MACD_Slowing, PriceField, MODE_MAIN, i);
      UP_macdprevious = iMACD(Symbol(), Period(), UP_MACD_Fast, UP_MACD_Slow, UP_MACD_Slowing, PriceField, MODE_MAIN, i+1);
    //UP_macdafter = iMACD(Symbol(), Period(), UP_MACD_Fast, UP_MACD_Slow, UP_MACD_Slowing, PRICE_CLOSE, MODE_MAIN, i-1);
      
      UP_macd_signow = iMACD(Symbol(), Period(), UP_MACD_Fast, UP_MACD_Slow, UP_MACD_Slowing, PriceField, MODE_SIGNAL, i);
      UP_macd_sigprevious = iMACD(Symbol(), Period(), UP_MACD_Fast, UP_MACD_Slow, UP_MACD_Slowing, PriceField, MODE_SIGNAL, i+1);
    //UP_macd_sigafter = iMACD(Symbol(), Period(), UP_MACD_Fast, UP_MACD_Slow, UP_MACD_Slowing, PRICE_CLOSE, MODE_SIGNAL, i-1);
      
      
      DN_macdnow = iMACD(Symbol(), Period(), DN_MACD_Fast, DN_MACD_Slow, DN_MACD_Slowing, PriceField, MODE_MAIN, i);
      DN_macdprevious = iMACD(Symbol(), Period(), DN_MACD_Fast, DN_MACD_Slow, DN_MACD_Slowing, PriceField, MODE_MAIN, i+1);
    //DN_macdafter = iMACD(Symbol(), Period(), DN_MACD_Fast, DN_MACD_Slow, DN_MACD_Slowing, PRICE_CLOSE, MODE_MAIN, i-1);
      
      DN_macd_signow = iMACD(Symbol(), Period(), DN_MACD_Fast, DN_MACD_Slow, DN_MACD_Slowing, PriceField, MODE_SIGNAL, i);
      DN_macd_sigprevious = iMACD(Symbol(), Period(), DN_MACD_Fast, DN_MACD_Slow, DN_MACD_Slowing, PriceField, MODE_SIGNAL, i+1);
    //DN_macd_sigafter = iMACD(Symbol(), Period(), DN_MACD_Fast, DN_MACD_Slow, DN_MACD_Slowing, PRICE_CLOSE, MODE_SIGNAL, i-1);
          
    
    
      CrossUp[i]=EMPTY_VALUE;
      CrossDown[i]=EMPTY_VALUE;
   
       if ((UP_macdnow > UP_macd_signow) && (UP_macdprevious < UP_macd_sigprevious))
          {
          if (i==1 && flagval1==0)
          {
          flagval1=1;
          flagval2=0;
          if (AlertON) Alert("MACD2 BUY Signal - ",Symbol()," M",Period());
          if (EmailON) SendMail("MACD2 BUY signal alert","BUY signal at Ask="+DoubleToStr(Ask,4)+", Bid="+DoubleToStr(Bid,4)+", Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());
          }
          CrossUp[i] = Low[i] - UParrowDisplacement*iATR(NULL,0,20,i);
          CrossDown[i]=EMPTY_VALUE;
          }
      
   
 else if ((DN_macdnow < DN_macd_signow) && (DN_macdprevious > DN_macd_sigprevious)) 
          {
       if (i==1 && flagval2==0)
          {
          flagval2=1;
          flagval1=0;
      if (AlertON) Alert("MACD2 SELL Signal - ",Symbol()," M",Period());
      if (EmailON) SendMail("MACD2 SELL signal alert","SELL signal at Ask="+DoubleToStr(Ask,4)+", Bid="+DoubleToStr(Bid,4)+", Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());
          }
          CrossDown[i] = High[i] + DNarrowDisplacement*iATR(NULL,0,20,i);
          CrossUp[i]=EMPTY_VALUE;
   
     
     
  
     }
    }
   }
   for (i=0; i<Bars; i++)
   {
      if (CrossDown[i]!=EMPTY_VALUE) { Commenter(-1); break; }
      if (CrossUp[i]  !=EMPTY_VALUE) { Commenter( 1); break; }
   }      
   return(0);
}
  
     
void Commenter(int Dir) 
{
    if (ShowText)
    {
      ObjectCreate(TextDir,OBJ_LABEL,0,0,0);
      ObjectSet(TextDir,OBJPROP_XDISTANCE,TextPositionX);
      ObjectSet(TextDir,OBJPROP_YDISTANCE,TextPositionY);
      if (Dir == 1) ObjectSetText(TextDir,"MACD2 BUY",Fontsize,"Arial Black", UPTextcolor);
      if (Dir ==-1) ObjectSetText(TextDir,"MACD2 SELL",Fontsize,"Arial Black",DNTextcolor);
   }
   
return; 
}
 
  
 